UNIT uDisplay;
(* ******************************************************************** *)
(* K L A S S E : TDisplay                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : 0.9                                                    *)
(* Autor       :                                                        *)
(* Beschreibung: Die Klasse bildet ein dummes Display mit diskreten     *)
(*							 Lampen ab.                                             *)
(*                                                                      *)
(* Compiler    : Delphi 5.0                                             *)
(* Aenderungen : 0.9	11-MAY-01                                         *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================
uses uGrafik, graphics,
	uLampe,
  uZeit;

type
  TDisplay = class(TObject)
   private
   	Kasten : array[1..20,1..40] of TLampe;
   public
    constructor Create;
    procedure LampeEin(zeile,spalte : integer);
    procedure LampeAus(zeile,spalte : integer);
    procedure LampenfarbeSetzen(zeile,spalte  : integer; F:TColor);
    procedure Zeigen;
    procedure Entfernen;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Methoden
--------

Create
   Auftrag: alle Lampen erzeugen und einsetzen
   vorher : D. existiert
   nachher: Display hat 20 x 40 Lampen

   Anfrage:
   vorher :
   nachher:

--------------------------------------------------------------------- *)

IMPLEMENTATION
// ====================================================================

constructor TDisplay.Create;
// --------------------------------------------------------------------
var
	sp, zei : integer;
  lampe   : TLampe;
begin
  inherited Create; // alles Gute kommt von oben
  begin
	for zei := 1 to 20 do
    for sp := 1 to 40 do
  	begin
  		lampe := TLampe.Create;  // 800 diskrete Lampen herstellen
    	Kasten[zei,sp] := lampe; // und einschrauben
    end;
  end;
end;

procedure TDisplay.LampeEin(zeile,spalte  : integer);
// --------------------------------------------------------------------
var
  lampe   : TLampe;
begin
   lampe := Kasten[zeile,spalte];
   lampe.Einschalten;
end;

procedure TDisplay.LampeAus(zeile,spalte  : integer);
// --------------------------------------------------------------------
var
  lampe   : TLampe;
begin
	lampe := Kasten[zeile,spalte];
  lampe.Ausschalten;
end;


procedure TDisplay.LampenfarbeSetzen(zeile,spalte  : integer; F:TColor);
// --------------------------------------------------------------------
var
  lampe   : TLampe;
begin
	lampe := Kasten[zeile,spalte];   // Lampe bestimmen
  lampe.SetLeuchtfarbe(F);
end;


procedure TDisplay.Zeigen;
// --------------------------------------------------------------------
var
	sp,
  zei,
  abstand,
  naechsteZeile : integer;
  lampe   			: TLampe;

begin
	abstand := 10;
	naechsteZeile := 10;

	for zei := 1 to 20 do
    for sp := 1 to 40 do
  	begin
  		lampe := Kasten[zei,sp];
      lampe.SetPos(abstand , naechsteZeile);
   		lampe.Zeigen;
      abstand := abstand + 10;

      if sp = 40
      then
        begin
          naechsteZeile := naechsteZeile + 10;
          abstand := 10;
        end;
    end;
end;


procedure TDisplay.Entfernen;
// --------------------------------------------------------------------
var
  sp, zei : integer;
  lampe   : TLampe;

begin
  for zei := 1 to 20 do
   for sp := 1 to 40 do
		begin
      lampe := Kasten[zei,sp];
      lampe.Entfernen;
    end;
end;

END.
