unit uFenster;
(* ******************************************************************** *)
(* K L A S S E : 									                                      *)
(* -------------------------------------------------------------------- *)
(* Version     : 0.9                                                    *)
(* Autor       : S. Spolwig,                                            *)
(* Beschreibung: Die Klasse steuert die Anzeige eines dummen Displays	  *)
(* Zweck       : Algorithmen bis der Doktor kommt ...                   *)
(* Compiler    : Delphi 5.0                                             *)
(* Aenderungen : 0.9	11-MAY-01                                         *)
(* ******************************************************************** *)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uGrafik,
  uDisplay,
  uZeit;

type
  TFensterFrm = class(TForm)
    Panel1		: TPanel;
    EndeBtn		: TButton;
    ObenRotBtn: TButton;
    BildImg		: TImage;
    AusBtn		: TButton;
    Muster		: TButton;
    LaufBtn   : TButton;
    procedure EndeBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AusBtnClick(Sender: TObject);
    procedure ObenRotBtnClick(Sender: TObject);
    procedure MusterClick(Sender: TObject);
    procedure LaufBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FensterFrm    : TFensterFrm;
  Display       : TDisplay;
  Zeichenblatt  : TZeichenblatt;

implementation
{$R *.DFM}
// ====================================================================
var
  LaufschriftAus: boolean;

procedure TFensterFrm.FormCreate(Sender: TObject);
// --------------------------------------------------------------------
begin
	Zeichenblatt := TZeichenblatt.Create;
  Zeichenblatt.SetLink(BildImg);
  Zeichenblatt.Zeigen;
  Display := TDisplay.Create;
  Display.Zeigen;
end;

procedure TFensterFrm.EndeBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  if LaufschriftAus = true
  then
    begin
      Display.Entfernen;
      Display.Free;
      Zeichenblatt.Entfernen;
      Close;
    end;
end;

procedure TFensterFrm.AusBtnClick(Sender: TObject);
// --------------------------------------------------------------------
var zei, sp : integer;
begin
  LaufschriftAus := true;
	for zei := 1 to 20 do
   for sp := 1 to 40 do
    Display.LampeAus(zei,sp);
end;

procedure TFensterFrm.ObenRotBtnClick(Sender: TObject);
// --------------------------------------------------------------------
var zei, sp : integer;
begin
	for zei := 1 to 10 do
   for sp := 1 to 40 do
   begin
     Display.LampenfarbeSetzen(zei,sp,clRED);
     Display.LampeEin(zei,sp);
   end;
end;

procedure TFensterFrm.MusterClick(Sender: TObject);
// --------------------------------------------------------------------
var zei, sp : integer;
begin
	for zei := 3 to 8 do
   for sp := 5 to 10 do
   begin
   	if (((sp = 5) or (sp = 10)) or (zei = 5))
    then  Display.LampenfarbeSetzen(zei,sp,clYellow);
    Display.LampeEin(zei,sp);
   end;
end;

procedure TFensterFrm.LaufBtnClick(Sender: TObject);
// --------------------------------------------------------------------
var sp, zei : integer;
begin
  LaufschriftAus := false;
  for sp := 1 to 40 do
   for zei := 13 to 16 do
   begin
     Display.LampenfarbeSetzen(zei,sp,clYellow);
   end;

  repeat
    sp := 2;
    while (sp < 40) do
    begin
     Display.LampeEin(13,sp-1);
     Display.LampeEin(14,sp);
     Display.LampeEin(15,sp-1);
     Zeit.SetPause(10);
     Display.LampeAus(13,sp-1);
     Display.LampeAus(14,sp);
     Display.LampeAus(15,sp-1);
     sp := sp + 1;
    end;
  until LaufschriftAus;
end;

end.
