UNIT uLampe;
(* ******************************************************************** *)
(* K L A S S E : TLampe                                                 *)
(* -------------------------------------------------------------------- *)
(* Version     : 0.9                                                    *)
(* Autor       :                                                        *)
(* Beschreibung: Die Klasse bildet eine Lampe fr ein Display ab.   		*)
(*                                                                      *)
(* Compiler    : Delphi 5.0                                             *)
(* Aenderungen : 0.9	11-MAY-01                                         *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================
uses uGrafik, graphics;

type
  TLampe   = class(TKreis)
   private
    Leuchtfarbe : TColor;
   public
    constructor Create;
    procedure SetLeuchtfarbe (F: TColor);
    function  GetLeuchtfarbe : TColor;
    procedure Einschalten;
    procedure Ausschalten;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : TKreis


Methoden
--------

Init
   Auftrag:
   vorher :
   nachher:

   Anfrage:
   vorher :
   nachher:

--------------------------------------------------------------------- *)

IMPLEMENTATION
// ====================================================================

constructor TLampe.Create;
// --------------------------------------------------------------------
begin
	inherited Create;
  SetFarbe(clGray);
  SetLeuchtfarbe(clBlack);
  SetRadius(5);
end;


procedure TLampe.SetLeuchtfarbe (F: TColor);
// --------------------------------------------------------------------
begin
  Leuchtfarbe := F;
end;


function TLampe.GetLeuchtfarbe : TColor;
// --------------------------------------------------------------------
begin
  Result := GetLeuchtFarbe;
end;

procedure TLampe.Einschalten;
// --------------------------------------------------------------------
begin
  SetFuellFarbe(Leuchtfarbe);
  Zeigen;
end;

procedure TLampe.Ausschalten;
// --------------------------------------------------------------------
begin
  SetFuellFarbe(clBlack);
  Zeigen;
end;


END.
